'' SD Copy - copies a file from SD to flash
'' JT Cook - http://www.avalondreams.com - 10-01-10
''
CON

  PAL=%0001
  NTSC=%0000
  Hydra = 0
  Hybrid = 1
''Custom hardware configurations
'{ C3 setup
  _clkmode = xtal1 + pll16x    
  _xinfreq = 5_000_000         
  _memstart = $10      ' memory starts $10 in!!! (this took 2 headaches to figure out)  
  Key_Pins    = 26   ''pin location for keyboard
  Video_Pins = %001_0101   ''pin location for video out
  V_NP = NTSC ''video type - NTSC
  ''setup pin groupings for audio
  Audio_Pins = %00000001_00000000_00000000_00000000 '' 1 <<24
               '- CTR   PLL -------- BPIN   --- APIN  
  Audio_Ctra = %0_00110_000_00000000_000000_000_011000  ''APIN = 24
  Use_Key = 1 'set 1 because we want to use the keyboard and joypad
  Console = 0
  Audio_pin=24
  kilobyte= 1024
' }



 ''used for video driver
 SCANLINE_BUFFER = $7F00           
 request_scanline       = SCANLINE_BUFFER-4  'address of scanline buffer for TV driver
 tilemap_adr            = SCANLINE_BUFFER-8  'address of tile map
 tile_adr               = SCANLINE_BUFFER-12 'address of tiles
 border_color           = SCANLINE_BUFFER-16 'address of border color 
 sprite_adr             = SCANLINE_BUFFER-20  'address of where sprites are stored
 sprite_x_adr           = SCANLINE_BUFFER-24 'X location of 8 sprites
 sprite_y_adr           = SCANLINE_BUFFER-32 'Y location of 8 sprites
 sprite_number          = SCANLINE_BUFFER-40 'address of images of 8 sprites
 sprite_x_flip          = SCANLINE_BUFFER-48 'flag to flip sprite on x axis
 sprite_y_flip          = SCANLINE_BUFFER-49 'flag to flip sprite on y axis
 Font_offset = 14 ''where font starts
 Max_Tiles  = 130

   spiCnt    =  8                      ' SPI select count 0->1->0
   spiDI     =  9                      ' SPI MOSI (or DI)
   spiDO     = 10                      ' SPI MISO (or DO)
   spiClk    = 11                      ' SPI Clock 0->1->0
   spiSel    =  5                      ' SPI select for microSD card
   spiClr    = 25                      ' SPI select clear 1->0->1

 
OBJ
  tv_game_gfx : "JTC_Tile_Drv.spin"  'JTC's Tile Driver
  fsrw: "fsrwFemto"                      ' Modified SD routines
  flash: "jtc_c3_flash_v001.spin"
VAR
   long Tile_Map_Adr ''address to tilemap for graphics driver
   long TV_Type  ''NTSC or PAL
   long joypad ''joy pad
   long joypadold ''old status of joypad
   byte tile_gfx[(64*Max_Tiles)] 'tile graphics space
   'sd car routines
     byte command[32]
     byte f0[32]
     byte tbuf[20] ' SD Vars
     long ioControl[2] 
     long tp
     byte strbuff[5]

  byte data_buffer[kilobyte]
  byte test_buffer[kilobyte]
  long buffer_size
  long flash_ptr
  byte numbertext[8]
PUB start | n               
  ''set up graphics driver
  tv_game_gfx.Set_Border_Color($02) 'set border color
  ''NTSC or PAL
  TV_Type:=V_NP
  tv_game_gfx.start(Video_Pins,TV_Type) 'start graphics driver
  ''clear sound stuff
' Long[Tile_Adr]:=@TileFile 'grab address of tile graphics
  Long[Tile_Adr]:=@tile_gfx
  Tile_Map_Adr:=LONG[CONSTANT($7F00-8)] 'grab address of tile map

  repeat n from 0 to (64*Max_Tiles) 'tiles
    tile_gfx[n]:=$F2 'set a default color to black 
  ''copy 1 bit font to 8 bit tiles
  repeat n from 0 to 90 ''90
    tv_game_gfx.Convert_Tile(@Char_data, n+Font_Offset,n, $02, $06)


  ''clear screen
  repeat n from 0 to CONSTANT((32*24)-1)
    byte[Tile_Map_Adr+n]:=0

  copy_file(string("uwelt.snd")) 'copies file from SD card to EEPROM
  
  'Play_music (0)
''---end
  repeat
   tv_game_gfx.Wait_Vsync ''wait for vertical retrace

pub copy_file (file_name) | n, n2, r
  fsrw.start(@ioControl)
  flash.start ' start flash driver
  ''show intro text screen
 Print_String(1,1,string("SD Card flash loader"))
'----mount SD carde
 r:= \fsrw.mount(spiSel,spiClr,spiCnt,spiDI,spiDO,spiClk)
 if r<0
      Print_String(1,2,string("SD Card not detected... HALTED"))
      repeat 
 else
       Print_String(1,2,string("SD Card mounted"))
'---- load file
 r := fsrw.popen(file_name,"r")
 if r<0
      Print_String(1,3,string("file not found... HALTED"))
      repeat 
 else
      Print_String(1,3,string("Opened file"))

  Print_String(1,4,string("Writing file to flash.."))'
  
  buffer_size:=0 'reset buffer
  flash_ptr:=0'reset flash address
  n2:=0
  
 repeat

    repeat n from 0 to (kilobyte -1)
     flash.SPI_Select_Channel(0)'reset channel
     flash.SPI_Select_Channel(5)'set channel back to SD card
   
     r := fsrw.pgetc
     if r < 0 ''eof
      flash.Flash_Write( flash_ptr, @data_buffer, n)
      Print_String(1,7,string("EOF"))
      quit

     else     
      byte[@data_buffer+n]:=r
'     byte[@data_buffer+n]:=$FF
      
    if r<0
      quit 'eof break
    else    
      n2++
      Int_To_String(@NumberText, n2)
      Print_String(1,5,@NumberText)
      Int_To_String(@NumberText, flash_ptr)
      Print_String(1,6,@NumberText)
      flash.Flash_Write( flash_ptr, @data_buffer, kilobyte)
      flash_ptr+=kilobyte 'advance pointer on flash      
 Print_String(1,8,string("Done!"))
     

PUB Int_To_String(adr, i) | t
' does an sprintf(str, "%05d", i); job
adr+=(8-1)
repeat t from 0 to 8
  BYTE[adr] := (i // 10) + 48
  i/=10
  adr--      

PUB Print_String(x,y,adr) | n, text_adr
'' prints a string
  n:=0
  text_adr:=adr
  repeat until byte[text_adr+n] == 0
    tv_game_gfx.Place_Tile_XY(x+n,y,byte[text_adr+n]+Font_offset-32) ''write characer
    n++
  
DAT
 ''sprite graphics
'SpriteFile file "sprite.spr"
 ''tile graphics
'TileFile file "font.til"

Char_data
'enter, special characters
byte 0,0,0,0,0,0,0,0 ' Enter/Clear - 32              
byte 24,24,24,24,0,0,24,0 ' ! - 33
byte 102,102,102,0,0,0,0,0 ' " - 34
byte 102,102,255,102,255,102,102,0 ' # - 35
byte 24,62,96,60,6,124,24,0 '$ - 36
byte 98,102,12,24,48,102,70,0' % - 37
byte 60,102,60,56,103,102,63,0 ' & - 38
byte 6,12,24,0,0,0,0,0 ' ' - 39              
byte 12,24,48,48,48,24,12,0 ' ( - 40
byte 48,24,12,12,12,24,48,0 ' ) - 41
byte 0,102,60,255,60,102,0,0 ' * - 42
byte 0, 24,24,126,24,24,0,0 ' +  - 43
byte 0,0,0,0,0,24,24,48 ' ,  44
byte 0,0,0,126,0,0,0,0 ' - - 45
byte 0,0,0,0,0,24,24,0 ' . - 46              
byte 0,3,6,12,24,48,96,0 ' / - 47
'Numbers 0-9
byte 60,102,110,118,102,102,60,0 ' 0 - 48
byte 24,24,56,24,24,24,126,0 ' 1 - 49
byte 60,102,6,12,48,96,126,0 ' 2 - 50
byte 60,102,6,28,6,102,60,0 ' 3 - 51
byte 6,14,22,102,127,6,6,0 ' 4 - 52
byte 126,96,124,6,6,102,60,0 ' 5 - 53              
byte 60,102,96,124,102,102,60,0 ' 6 - 54
byte 126,102,12,12,12,12,12,0 ' 7 - 55
byte 60,102,102,60,102,102,60,0 ' 8 - 56
byte 60,102,102,62,6,102,60,0 ' 9 - 57
'special characters
byte 0,0,24,0,0,24,0,0 ' : - 58
byte 0,0,24,0,0,24,24,48 ' ; - 59
byte 14,24,48,96,48,24,14,0 ' < - 60
byte 0,0,126,0,126,0,0,0 ' = - 61
byte 112,24,12,6,12,24,112,0 ' > - 62
byte 60,102,6,12,24,0,24,0 ' ? - 63
byte 60,102,110,110,96,98,60,0 ' @ - 64
'A-Z upper case
byte 24,60,102,126,102,102,102,0 ' A - 65
byte 124,102,102,124,102,102,124,0 ' B - 66
byte 60,102,96,96,96,102,60,0 ' C - 67
byte 120,108,102,102,102,108,120,0 ' D - 68
byte 126,96,96,120,96,96,126,0 ' E - 69
byte 126,96,96,120,96,96,96,0 ' F - 70
byte 60,102,96,110,102,102,60,0 ' G - 71
byte 102,102,102,126,102,102,102,0 ' H - 72
byte 60,24,24,24,24,24,60,0 'I - 73
byte 30,12,12,12,12,108,56,0 ' J - 74
byte 102,108,120,112,120,108,102,0 ' K - 75
byte 96,96,96,96,96,96,126,0 ' L - 76
byte 99,119,127,107,99,99,99,0 ' M - 77
byte 102,118,126,110,102,102,102,0 ' N - 78
byte 60,102,102,102,102,102,60,0 ' O - 79
byte 124,102,102,124,96,96,96,0 ' P - 80
byte 60,102,102,102,102,102,60,14 ' Q - 81
byte 124,102,102,124,120,108,102,0 ' R - 82
byte 60,102,96,60,6,102,60,0 ' S - 83
byte 126,24,24,24,24,24,24,0 ' T - 84
byte 102,102,102,102,102,102,60,0 ' U - 85
byte 102,102,102,102,102,60,24,0 ' V - 86
byte 99,99,99,107,127,119,99,0 ' W - 87
byte 102,102,60,24,60,102,102,0 ' X - 88
byte 102,102,102,60,24,24,24,0 ' Y - 89
byte 126,6,12,24,48,112,126,0 ' Z - 90
'special characters
byte 60,48,48,48,48,48,60,0 ' [ - 91
byte 0,96,48,24,12,6,3,0 ' \ - 92
byte 60,12,12,12,12,12,60,0 ' ] - 93
byte 24,60,102,0,0,0,0,0 ' ^ - 94
byte 0,0,0,0,0,0,255,0 ' _ - 95
byte 96,48,24,0,0,0,0,0 ' ` - 96
'a-z lower case
byte 0,0,60,6,62,102,62,0 'a - 97
byte 0,96,96,124,102,102,124,0 ' b - 98
byte 0,0,60,96,96,96,60,0 ' c - 99
byte 0,6,6,62,102,102,62,0 ' d - 100
byte 0,0,60,102,126,96,60,0 ' e - 101
byte 0,14,24,62,24,24,24,0 ' f - 102
byte 0,0,62,102,102,62,6,124 ' g - 103
byte 0,96,96,124,102,102,102,0 ' h - 104
byte 0,24,0,56,24,24,60,0 ' i -105
byte 0,6,0,6,6,6,6,60 ' j -106
byte 0,96,96,108,120,108,102,0 ' k - 107
byte 0,56,24,24,24,24,60,0 ' l - 108
byte 0,0,102,127,127,107,99,0 ' m - 109
byte 0,0,124,102,102,102,102,0 ' n - 110
byte 0,0,60,102,102,102,60,0 ' o - 111
byte 0,0,124,102,102,124,96,96 ' p - 112
byte 0,0,62,102,102,62,6,6 ' q - 113
byte 0,0,124,102,96,96,96,0 ' r - 114
byte 0,0,62,96,60,6,124,0 ' s - 115
byte 0,24,126,24,24,24,14,0 ' t - 116
byte 0,0,102,102,102,102,62,0 ' u - 117
byte 0,0,102,102,102,60,24,0 ' v - 118
byte 0,0,99,107,127,62,54,0 ' w - 119
byte 0,0,102,60,24,60,102,0 ' x - 120
byte 0,0,102,102,102,62,12,120' y - 121
byte 0,0,126,12,24,48,126,0 ' z - 122